#include <string.h>

size_t ffread(void *ptr,size_t size,size_t N,FILE *f) {
   long tot,i;
   size_t rv;
   char *cp,x;
   cp=(char*)ptr;
   tot=N*size;
   rv=fread(ptr,size,N,f);
   for (i=0;i<tot;i+=4) {
      x=cp[i]; cp[i]=cp[i+3]; cp[i+3]=x;
      x=cp[i+1]; cp[i+1]=cp[i+2]; cp[i+2]=x;
   }
   return rv;
}

size_t ffwrite(const void *ptr,size_t size,size_t N,FILE *f) {
   char *cp,x;
   long tot,i;
   size_t rv;
   tot=N*size;
   cp=(char*)calloc(tot,1);
   if (!cp) {
      printf("Memory error in ffwrite\n");
      exit(0);
   }
   memcpy(cp,ptr,tot);
   for (i=0;i<tot;i+=4) {
      x=cp[i]; cp[i]=cp[i+3]; cp[i+3]=x;
      x=cp[i+1]; cp[i+1]=cp[i+2]; cp[i+2]=x;
   }
   rv=fwrite(cp,size,N,f);
   free(cp);
   return rv;
}

size_t sfread(void *ptr,size_t size,size_t N,FILE *f) {
   long tot,i;
   size_t rv;
   char *cp,x;
   cp=(char*)ptr;
   tot=N*size;
   rv=fread(ptr,size,N,f);
   for (i=0;i<tot;i+=2) {
      x=cp[i]; cp[i]=cp[i+1]; cp[i+1]=x;
   }
   return rv;
}
