#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define NBAD 32
int BAD[NBAD][3]={
   {0,338,468},
   {0,358,548},
   {0,407,605},
   {0,450,565},
   {0,528,315},
   {0,576,530},
   {0,654,771},
   {0,738,425},
   {0,794,32},
   {1,250,322},
   {1,336,198},
   {1,398,350},
   {1,552,357},
   {1,631,97},
   {1,636,394},
   {1,790,563},
   {2,250,580},
   {2,396,405},
   {2,507,348},
   {2,611,722},
   {3,123,58},
   {3,134,155},
   {3,184,230},
   {3,320,72},
   {3,417,113},
   {3,440,382},
   {3,497,33},
   {3,539,135},
   {3,565,382},
   {3,573,580},
   {3,729,615},
   {3,746,50}
};
int vign[4][2]={{61,73},{59,39},{42,59},{57,55}};
int isep[4]={4,3,3,3};

int main(int argc,char**argv)

{
   FILE *fin,*fout;
   int i;

   if (argc!=4) {
      printf("usage: %s <input> <output> <bad columns>\n",argv[0]);
      exit(0);
   }
   if ((fin=fopen(argv[1],"r"))==NULL) {
      printf("Cannot open %s\n",argv[1]);
      exit(0);
   }
   if ((fout=fopen(argv[2],"w"))==NULL) {
      printf("Cannot open %s\n",argv[2]);
      exit(0);
   }
   fscanf(fin,"%d",&i);
   while (!feof(fin)) {
      double A,B,C,D,E,F,G,H,I,J;
      fscanf(fin,"%lf %lf %lf %lf %lf %lf %lf %lf %lf %lf",&A,&B,&C,&D,&E,&F,&G,&H,&I,&J);
      if (A>=vign[i][0] && A<799-isep[i] && B>=vign[i][1] && B<795) {
	 int pOK=1,j;
	 if (atoi(argv[3])) for (j=0;j<NBAD && pOK;j++) if (i==BAD[j][0] && fabs(A-BAD[j][1])<isep[i] && B>BAD[j][2]-isep[i]) pOK=0;
	 if (pOK) {
	    fprintf(fout,"%d %6.2f %6.2f ",i,A,B);
	    if (C<999999.5) fprintf(fout,"%8.1f",C);
	    else fprintf(fout,"%8.2e",C);
	    fprintf(fout," %6.2f %6.3f %6.3f %8.4f %7.1f %6.3f %d\n",D,E,F,G,H,I,(int)(J+.5));
	 }
      }
      fscanf(fin,"%d",&i);
   }
   fclose(fout);
   fclose(fin);
   return 0;
}
