#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main(int argc,char**argv)

{
   FILE *fin,*fout;
   double apcor[4];
   int i;

   if (argc!=5 && argc!=7) {
      printf("usage: %s <input> <output> <dPC> <dWF1> <<dWF2> <dWF3>>\n",argv[0]);
      exit(0);
   }
   if ((fin=fopen(argv[1],"r"))==NULL) {
      printf("Cannot open %s\n",argv[1]);
      exit(0);
   }
   if ((fout=fopen(argv[2],"w"))==NULL) {
      printf("Cannot open %s\n",argv[2]);
      exit(0);
   }
   for (i=0;i<2;i++) apcor[i]=atof(argv[3+i]);
   for (i=2;i<4;i++)
      if (argc==5) apcor[i]=apcor[1];
      else apcor[i]=atof(argv[3+i]);
   fscanf(fin,"%d",&i);
   while (!feof(fin)) {
      double A,B,C,D,E,F,G,H,I,J;
      fscanf(fin,"%lf %lf %lf %lf %lf %lf %lf %lf %lf %lf",&A,&B,&C,&D,&E,&F,&G,&H,&I,&J);
      fprintf(fout,"%d %6.2f %6.2f ",i,A,B);
      if (C<999999.5) fprintf(fout,"%8.1f",C);
      else fprintf(fout,"%8.2e",C);
      E+=apcor[i];
      if (E>99.999) {
	 E=99.999;
	 J=6;
      }
      fprintf(fout," %6.2f %6.3f %6.3f %8.4f %7.1f %6.3f %d\n",D,E,F,G,H,I,(int)(J+.5));
      fscanf(fin,"%d",&i);
   }
   fclose(fout);
   fclose(fin);
   return 0;
}
